﻿package 
{
	import flash.display.Bitmap;
	import flash.display.StageScaleMode;
	import flash.display.Shader;
	import flash.display.ShaderPrecision;
	import flash.filters.ShaderFilter;
	
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	/**
	 * @author nicoptere
	 * htt://en.nicoptere.net/
	 * 
	 * panorama picture from
	 * http://photoshipone.com/images/spices/equirectangular-pano.jpg
	 * 
	 * original script
	 * http://www.lightspacewater.net/Software/
	 */
	
	public class Azimuthal extends Sprite 
	{
		
		
		private var photo:Bitmap;
		private var shader:Shader;
		private var filter:ShaderFilter;
		
		private var Z:Number = 20;
		private var FOV:Number = 30;
		private var method:Number = 0;
		
		[Embed(source = 'equirectangular_pano.jpg')]private var img:Class;
		[Embed(source = "Azimuthal.pbj", mimeType = "application/octet-stream")]private var azimuthal:Class;
		
		public function Azimuthal():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			stage.scaleMode = StageScaleMode.NO_SCALE;
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			photo = new img() as Bitmap;
			addChild( photo );
			reset( azimuthal );
			
		}
		
		private function reset( c:Class ):void 
		{
			
			//removeEventListener( Event.ENTER_FRAME, update );
			
			shader = new Shader(  new c() );
			
			filter = new ShaderFilter( shader ); 
			
			addEventListener( Event.ENTER_FRAME, update );
			
		}
		private function update( e:Event ):void
		{
			
			if ( filter == null ) return;
			
			
			//asigning values
			FOV = FOVslider.value;
			Z = Zslider.value;
			
			try {
				method = methodSelector.selectedItem.data;
			}catch ( err:Error ) 
			{
				method = 0;
			}
			
			
			//processing shader
			shader.data.Z.value = [ Z ];
			shader.data.fov.value = [ FOV ];
			shader.data.method.value = [ method ];
			shader.data.imageSize.value = [ photo.width, photo.height ];
			
			//applies filter
			photo.filters = [ filter ];
			
			FOVvalue.text = FOV.toString();
			Zvalue.text = Z.toString();
		}
	}
	
}